Program NPef

  use sep
  use read_hist_param
  use npef_find
  use nhelix
  use createnhelixmod
  use io_nfilt
  use error_check
  
  implicit none
  
  integer, external                  :: getch
  integer                            :: nl, niter, prec,ritestat,tt(1000),stat
  integer, dimension(:), allocatable :: a,center,gap,npatch,patch,nn,nsc,jump
  real                               :: eps, epsl
  character(len=1024)                :: out
  real,    dimension(:), pointer     :: data,mask
  logical, dimension(:), pointer     :: lmask
  real,    dimension(:), allocatable :: oo,dd
  type(nfilter)                      :: pef, pef2
  
! __________________________________________________________
! ___________Initialize and allocate parameters_____________
! __________________________________________________________
  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim),a(dim),center(dim),gap(dim),npatch(dim),nsc(1),jump(dim))
! __________________________________________________________
! ___________Read history and parameters____________________
! __________________________________________________________
  call history_read(nn,oo,dd)
  call pefpar_read(a,center,gap,npatch,nsc,jump,out)
  call cgpar_read(niter,prec,eps,epsl,nl)
! __________________________________________________________
! ___________Allocate data arrays and read data_____________ 
! __________________________________________________________
  allocate(data(product(nn)),mask(product(nn)),patch(product(nn)),lmask(product(nn)))
  call sep_read(data)
  if (exist_file ("maskin")) then
     call sep_read(mask,"maskin")
     lmask=.true.
     where (mask==0)
        lmask=.false.
     end where
  else
     lmask=.true.
  end if

! __________________________________________________________
! ___________Create PEF, set patch table (wrong)____________
! __________________________________________________________
  patch=product(npatch)
  pef = createnhelix( nn, center, gap, a, patch)
! __________________________________________________________
! ___________Call main program to estimate PEF______________
! __________________________________________________________

!  pef2%pch=pef%pch
write(0,*)"NPEF: pef"
  call pefcheck(pef)
! __________________________________________________________
! ________________Do nonlinear iterations___________________
! __________________________________________________________
  call lmms(lmask,"lmask")
  call npef_find(pef,data,lmask,nn,oo,dd,a,center,gap,npatch,niter,eps,prec,epsl,nl)
! __________________________________________________________
! ___________Write out filter to external file______________
! __________________________________________________________

  ritestat=rite_nfilt(out,pef,nn,oo,dd)
! __________________________________________________________
! ___________Deallocate and close program___________________
! __________________________________________________________

  call sep_close()
  allocate(pef%mis(1),pef%pch(1));pef%pch=size(pef%hlx)
  call ndeallocate(pef)
  deallocate (nn,oo,dd,a,center,gap,npatch,data,mask,patch)
  call exit(0)
end Program NPef

