Program PEF2_fill

  use sep
  use helix
  use pef2fill
  use read_hist_param
  use error_check
  use bound
  implicit none

  integer                           :: iter, na1, na2, ia
  real                              :: a01, a02, eps
  integer, dimension(:),allocatable :: nn, a1, a2, m1, m2
  real,    dimension(:),pointer     :: oo,dd
  real,    dimension(:,:),pointer   :: data, model,rmov,mmov
  type(filter)                      :: pef1, pef2

write(0,*)"Main 1"

  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim), a1(dim),a2(dim),m1(dim),m2(dim))
write(0,*)"Main 2"

  call history_read(nn,oo,dd)
  call from_param("niter",iter)
  call from_param("eps",eps,-1.)
write(0,*)"Main 3"

  allocate(data(nn(1),nn(2)),model(nn(1),nn(2)))
  allocate(rmov(nn(1)*nn(2),iter),mmov(nn(1)*nn(2),iter))
write(0,*)"Main 4"

  call sep_read(data)
write(0,*)"Main 5"

! Read PEF #1

  call from_aux ("filt1", "n1", na1)
write(0,*)"Main 5.1"
  call allocatehelix (pef1, na1)
write(0,*)"Main 5.2"
 
  call from_aux ("filt1","a01", a01, 1.)
write(0,*)"Main 5.3"
  call from_aux ("filt1","n1",m1)
write(0,*)"Main 5.4"
  a1 = 1
  call from_aux ("filt1","a",a1, a1)
write(0,*)"Main 5.5"
  call from_aux ("filt1","lag", pef1%lag, (/ (ia, ia = 1, na1) /))
write(0,*)"Main 5.6",m1,nn,a1
 
  call boundn (nn, nn, a1, pef1)
write(0,*)"Main 5.7"
  call sep_read (pef1%flt, "filt1"); pef1%flt = pef1%flt/a01
write(0,*)"Main 6"

! Read PEF #2

  call from_aux ("filt2", "n1", na2)
  call allocatehelix (pef2, na2)
 
  call from_aux ("filt2","a02", a02, 1.)
  call from_aux ("filt2","n1",m2)
  a1 = 1
  call from_aux ("filt2","a",a2, a2)
  call from_aux ("filt2","lag", pef2%lag, (/ (ia, ia = 1, na2) /))
 
  call boundn (nn, nn, a2, pef2)
  call sep_read (pef2%flt, "filt2"); pef2%flt = pef2%flt/a02
write(0,*)"Main 7"

! Call main program
  if (eps>0) then
     call dospeffilleps(data,model,pef1,pef2,iter,rmov,mmov,eps)
  else
     call dospeffill(data,model,pef1,pef2,iter,rmov,mmov)
  end if
  call rmms2(rmov,"rmov ")
  call rmms2(mmov,"mmov ")

  call sep_write(model)

! write out movies
  call to_history("n1",nn(1),"rmov")
  call to_history("n2",nn(2),"rmov")
  call to_history("n3",iter,"rmov")
  call sep_write(rmov,"rmov")

  call to_history("n1",nn(1),"mmov")
  call to_history("n2",nn(2),"mmov")
  call to_history("n3",iter,"mmov")
  call sep_write(mmov,"mmov")

  deallocate(nn,oo,dd,a1,a2,m1,m2,data,model,rmov,mmov)
  call deallocatehelix(pef1)
  call deallocatehelix(pef2)
end Program PEF2_fill
