Program PEF2_fillns

  use sep
  use io_nfilt
  use nhelix
  use pef2fillns
  use read_hist_param
  use error_check
  use bound
  implicit none

  integer                           :: iter, na1, na2, ia, stat
  real                              :: a01, a02, eps
  integer, dimension(:),allocatable :: nn, a1, a2, m1, m2
  real,    dimension(:),pointer     :: oo,dd
  real,    dimension(:,:),pointer   :: data, model,rmov,mmov
  type(nfilter)                      :: pef1, pef2
  character(len=1024)               :: fname1,fname2

write(0,*)"Main 1"

  call sep_init(SOURCE)
  dim = sep_dimension()
  allocate(nn(dim),oo(dim),dd(dim), a1(dim),a2(dim),m1(dim),m2(dim))
write(0,*)"Main 2"

  call history_read(nn,oo,dd)
  call from_param("niter",iter)
  call from_param("eps",eps,-1.)
write(0,*)"Main 3"

  allocate(data(nn(1),nn(2)),model(nn(1),nn(2)))
  allocate(rmov(nn(1)*nn(2),iter),mmov(nn(1)*nn(2),iter))
write(0,*)"Main 4"

  call sep_read(data)
write(0,*)"Main 5"

! Read PEF #1

call from_param ("filt1",fname1,'pef.H')
stat=read_nfilt(fname1,pef1)

! Read PEF #2

call from_param ("filt2",fname2,'pef.H')
stat=read_nfilt(fname2,pef2)

! Call main program
  if (eps>0) then
     call dospeffillnseps(data,model,pef1,pef2,iter,rmov,mmov,eps)
  else
     call dospeffillns(data,model,pef1,pef2,iter,rmov,mmov)
  end if
  call rmms2(rmov,"rmov ")
  call rmms2(mmov,"mmov ")

  call sep_write(model)

! write out movies
  call to_history("n1",nn(1),"rmov")
  call to_history("n2",nn(2),"rmov")
  call to_history("n3",iter,"rmov")
  call sep_write(rmov,"rmov")

  call to_history("n1",nn(1),"mmov")
  call to_history("n2",nn(2),"mmov")
  call to_history("n3",iter,"mmov")
  call sep_write(mmov,"mmov")

  deallocate(nn,oo,dd,a1,a2,m1,m2,data,model,rmov,mmov)
!  call deallocatehelix(pef1)
!  call deallocatehelix(pef2)
end Program PEF2_fillns
