program SFill
  use sep
  use helix
  use fill_s
  use bound
  use read_hist_param
  use error_check
  implicit none
  integer                                     :: nm,ndat,stat,grid
  real                                        :: feps,fsig
  integer, dimension(:),allocatable           :: nn,fn
  real,    dimension(:),pointer               :: oo,dd,fo,fd,data,mask,points,model
  real,    dimension(:,:),pointer             :: coord
  logical, dimension(:),pointer               :: maskl
  logical                                     :: prec
  integer                                     :: na,ia, niter, n1, n2, do_rand0
  integer                                     :: maxlag, padin, padout, p1, p2
  real                                        :: a0
  integer, dimension (:), allocatable         :: m, a
  real,    dimension (:), allocatable, target :: mm, kk
  real,    dimension (:),             pointer :: pmm, pkk, xnull
  logical, dimension (:), allocatable, target :: known
  logical, dimension (:),             pointer :: pknown
  type( filter)                               :: pef

write(0,*)"AFill 1"
  call sep_init (SOURCE)
  dim = sep_dimension ()
write(0,*)"AFill 2"

  allocate(nn(dim),oo(dim),dd(dim),fn(dim),fo(dim),fd(dim))
  call history_read(nn,oo,dd)
  call fillgpar_read(fn,fo,fd)
  call from_param("eps",feps,1.)
  call from_param("grid",grid,0)
write(0,*)"AFill 3"

  allocate (m (dim), a (dim))
  call to_history ("dim",dim)
  call from_param ("prec", prec, .true.)
  call from_param ("niter", niter, 100)
  call from_aux ("filt", "n1", na)
  call allocatehelix (pef, na)
write(0,*)"AFill 4"

  call from_aux ("filt","a0", a0, 1.)
  call from_aux ("filt","n",m)
  a = 1
  call from_aux ("filt","a",a, a)
  call from_aux ("filt","lag", pef%lag, (/ (ia, ia = 1, na) /))
  call boundn (m, nn, a, pef)
  call sep_read (pef%flt, "filt"); pef%flt = pef%flt/a0
  call to_history ("lag", pef%lag)
write(0,*)"AFill 5"

  ndat=product(nn); nm=product(fn)
  allocate(data(ndat),mask(ndat),points(ndat),coord(ndat,dim),model(nm),maskl(ndat))

write(0,*)"AFill 6",ndat
  call sep_read(data)
  call sep_read(mask,"mask")

write(0,*)"AFill 7"

write(0,*)"Fill data, mask and pef read"

  maskl=.false.
  where (mask>0) maskl=.true.
  deallocate(mask)
write(0,*)"before grid"

  if (grid==0) then
write(0,*)"before grid"
     call bin2points(data,nn,oo,dd,maskl,points,coord)
     write(0,*)"Fill after bin2points"
     call lmms(maskl,"maskl")
     call rmms(data,"data ")
     call rmms(points,"point")
     call rmms2(coord,"coord")
     call spefcheck(pef)
     call fill(pef,points,coord,model,fn,fo,fd,prec,fsig,feps,niter)
  else
write(0,*)"before fill_grid"
     call fill_grid(pef,data,maskl,model,prec,fsig,feps,niter)
  end if

  write(0,*)"Fill after main call"
  call rmms(model,"model")
     call sep_write(model)
     call sep_close()
     deallocate(data,points,coord,model,maskl,nn,oo,dd,fn,fo,fd)

  deallocate (m, a)
  call deallocatehelix( pef)
  call exit (0)
end program SFill
