module helderiv_sc 
  use adj_mod
  use lapfac
  use helicon
  implicit none
  type( filter),   private  :: aa 
  contains
  subroutine helderiv_sc_init ( n1,na,eps,p )
    integer, intent (in) :: n1, na
    real,    intent (in) :: eps,p
    real                 :: a
    aa = lapfac2( eps, n1, na)
    a = 1+((1/abs(sum(aa%flt)))-1)*p
    aa%flt=aa%flt*a
    call helicon_init( aa)
  end subroutine helderiv_sc_init
  function helderiv_sc_lop ( adj, add, pp, qq) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: pp,qq 
    call adjnull (adj,add,pp,qq )
    call helderiv_sc_lop2(adj,pp,qq )
    stat=0
  end function helderiv_sc_lop
  subroutine helderiv_sc_lop2(adj,pp,qq)
    logical,intent(in) :: adj 
    real, dimension (:)  :: pp 
    real, dimension (:)  :: qq 
    integer stat1
    stat1 = helicon_lop( adj, .false.,  pp, qq)
  end subroutine helderiv_sc_lop2
  subroutine  helderiv_sc_close()
    call deallocatehelix( aa)
  end subroutine helderiv_sc_close
end module helderiv_sc
