module ihelderiv  
  use adj_mod
  use lapfac
  use polydiv
  implicit none
  type( filter),   private  :: aa 
  contains
  subroutine ihelderiv_init ( n1,n2,na,eps )
    integer, intent (in) :: n1, n2, na
    real,    intent (in) :: eps
    aa = lapfac2( eps, n1, na) 
    call polydiv_init( n1*n2,aa)
  end subroutine
  function ihelderiv_lop ( adj, add, pp, qq) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: pp,qq 
    call adjnull (adj,add,pp,qq )
    call ihelderiv_lop2(adj,pp,qq )
    stat=0
  end function 
  subroutine ihelderiv_lop2(adj,pp,qq)
    logical,intent(in) :: adj 
    real, dimension (:)  :: pp 
    real, dimension (:)  :: qq 
    integer stat1
    stat1 = polydiv_lop( adj, .false.,  pp, qq)
  end subroutine
  subroutine  ihelderiv_close()
    call deallocatehelix( aa)
  end subroutine 
end module 
