module mad_warped

  use helix
  use mad2pef
  use cartesian
  use cgstep_mod
  use random
  use solver_smp_mod
  use error_check
  use mask1
  use dottest
  
  implicit none

contains

  subroutine trackfill2          ( data1,data2,model,pef1,pef2,iter,rmov,mmov)
    type(filter)                 ::                  pef1,pef2
    real,dimension(:,:),pointer  ::data1,data2,model,               rmov,mmov
    real,dimension(:),allocatable :: data,m,m0
    integer                       ::                           iter, nd, n1,n2
    real, dimension(2)::dot1,dot2

    nd=size(data1)
    n1=size(model,1)
    n2=size(model,2)
    allocate(data(nd*2),m(nd),m0(nd))
    data(1:nd)=reshape(data1,(/nd/))
    data(nd+1:2*nd)=reshape(data2,(/nd/))
    m=reshape(model,(/ size(model) /))
    m0=data(1:nd)+data(nd+1:2*nd)

!    where (data(1:nd)/=0)
!       pef2%mis=.true.
!    end where
!    where (data(nd+1:2*nd)/=0)
!       pef1%mis=.true.
!    end where
    call spefcheck(pef1)
    call spefcheck(pef2)
    call rmms2(data1,"data1")
    call rmms2(data2,"data2")
    call rmms (data, "data ")
    call rmms2(model,"model")
    call rmms(m,"m    ")
    call rmms2(mmov,"mmov ")
    call rmms2(rmov,"rmov ")
write(0,*)"mad_warped 1"
    call mad2pef_init(pef1,pef2,size(model))
write(0,*)"mad_warped 2",size(model),size(data)
    call dot_test(mad2pef_lop,size(model),size(data),dot1,dot2)

    call solver_smp(m=m,                                    &
         d=data,                                   &
         Fop=mad2pef_lop,                               &
         stepper=cgstep,                             &
         niter=iter,                                &
         m0=m0,                          &
         mmov=mmov,                    &
         rmov=rmov,                     &
         verb=.true.)
    call mad2pef_close()
    call cgstep_close()
    model=reshape(m,(/n1,n2/))

    deallocate(data,m,m0)

  end subroutine trackfill2
   
end module mad_warped
