module nmhconest_new

use nhelix
use nhconest
use sep
use adj_mod
use error_check

implicit none

type(nfilter),save                   :: aa
integer, private, save               :: dim, ns, stat
real, dimension(:), pointer, save    :: databank
integer, dimension(:), pointer, save :: lagbank,mark,lagmark,patchbank
logical, dimension(:), pointer, save :: boundbank

contains

  subroutine nmhconest_new_init(databank_in,patchbank_in,boundbank_in,lagbank_in,   mark_in,   lagmark_in,aa_in)
   type(nfilter)    ::                                                                                    aa_in
    integer, pointer ::                     patchbank_in(:),          lagbank_in(:),mark_in(:),lagmark_in(:)
    real,    pointer ::     databank_in(:)
    logical, pointer ::                              boundbank_in(:)

    
    databank =>databank_in
    patchbank=>patchbank_in
    boundbank=>boundbank_in
    lagbank  =>lagbank_in
    mark     =>mark_in
    lagmark  =>lagmark_in
    aa       =aa_in
    ns = size(mark)-1
    
  end subroutine nmhconest_new_init
! ---------------------------------------------------------------------------
! ---------------------------------------------------------------------------    
       
  function nmhconest_new_lop ( adj, add, mm, dd) result(stat)
    integer            :: stat 
    logical,intent(in) :: adj,add 
    real,dimension(:)  :: mm,dd 
    call adjnull (adj,add,mm,dd )
    call nmhconest_new_lop2(adj,mm,dd )
    stat=0
  end function nmhconest_new_lop

  subroutine nmhconest_new_lop2( adj, mm, dd)
    logical                        :: adj 
    real, dimension(:)             :: mm, dd
    real, dimension(:),allocatable :: ddtemp
    real, dimension(:), pointer    :: datatemp
    integer, dimension(dim)        :: rn
    integer                        :: is, datsize, ia

    if (allocated(aa%pch)) then
       deallocate(aa%pch)
    endif
    if (allocated(aa%mis)) then
       deallocate(aa%mis)
    endif
    do is=1,ns                                      ! looping over scales
       datsize = mark(is+1)-mark(is)
       allocate(aa%mis(datsize),aa%pch(datsize),datatemp(datsize),ddtemp(datsize))
       ddtemp            =        dd(mark(is):mark(is+1)-1)
       datatemp          = databank(mark(is):mark(is+1)-1)
       aa%mis            = boundbank(mark(is):mark(is+1)-1)
       aa%pch            = patchbank(mark(is):mark(is+1)-1)

       do ia=1,maxval(aa%pch)
          aa%hlx(ia)%lag =   lagbank(lagmark(is):lagmark(is+1)-1)
       end do

       call nhconest_init( datatemp, aa,size(aa%hlx(1)%flt) )
       stat = nhconest_lop( adj, .true., mm, ddtemp )  ! Just normal nhconest--note add=.true.
       dd(mark(is):mark(is+1)-1) = ddtemp
       deallocate( datatemp, ddtemp,aa%pch,aa%mis)
    end do
    
  end subroutine nmhconest_new_lop2
! ---------------------------------------------------------------------------

! ---------------------------------------------------------------------------
  subroutine nmhconest_new_close( )
  end subroutine nmhconest_new_close
! ---------------------------------------------------------------------------

end module nmhconest_new







